<?php
/*
Plugin Name: Output Tag Manager

Plugin URI: http://082net.com/tag/output-tag-manager

Description: Display tags on WP 2.3 or later. This plugin powerd by <a href="http://www.neato.co.nz/ultimate-tag-warrior/">UTW</a>

Version: 0.11

Author: Choen, Youngmin
Author URI: http://082net.com/
*//*
Change Logs ::


Lisense : GPL(http://www.gnu.org/copyleft/gpl.html)
/*  Copyright 2006  Cheon, Young-Min  (email : 082net@gmail.com, site : http://082net.com)
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


class OTM_Display {
	var $formats;
	// tag variables
	var $counts, $tag_ids, $tag_links, $weights, $relweights, $weightranks;
	// arg variables
	var $rewrite;
	var $maxsize, $minsize, $unit, $orderby, $order, $maxcol, $mincol;
	var $number = 45;
	var $replacer = array();
	var $op;
	var $sep, $pre, $post;
	var $op_defaults = array(
			'smallest' => 88, 'largest' => 265, 'unit' => '%', 'number' => 45,
			'format' => 'flat', 'orderby' => 'name', 'order' => 'ASC',
			'maxcolor' => '#222222', 'mincolor' => '#DDDDDD',
			'sep' => '', 'before' => '', 'after'=>''
		);

	function OTM_Display() {
		global $wp_rewrite;
		$this->default_formats();
		$this->rewrite = ( is_object($wp_rewrite) && $wp_rewrite->using_permalinks() );
		$this->get_tags();
		$this->op = get_option('otm_options');
	}

	function default_formats() {
		$notagtext = __(' No Tags ', 'otm_domain');

		// Tag list
		$this->formats["default"] = array('pre'=>'', 'default'=>'%tagdisplay%', 'none'=>$notagtext, 'post'=>'');
		$this->formats["local"] = array('pre'=>'', 'default'=>'%localtag%', 'none'=>$notagtext, 'post'=>'');
		$this->formats["htmllist"] = array ("default"=>"<li>%taglink%</li>", "none"=>"<li>" . $notagtext . "</li>");
		$this->formats["technorati"] = array ("default"=>"%technoratitag%", "none"=>$notagtext );
		$this->formats["gadabe"] = array ("default"=>"%gadabetag%", "none"=>$notagtext );
		$this->formats["flickr"] = array ("default"=>"%flickrtag%", "none"=>$notagtext );
		$this->formats["delicious"] = array ("default"=>"%delicioustag%", "none"=>$notagtext );
		$this->formats["wikipedia"] = array ("default"=>"%wikipediatag%", "none"=>$notagtext );
		$this->formats["gadabe"] = array ("default"=>"%gadabetag%", "none"=>$notagtext );
		$this->formats["zniff"] = array ("default"=>"%znifftag%", "none"=>$notagtext );
		$this->formats["allblog"] = array ("default"=>"%allblogtag%", "none"=>$notagtext );
		$this->formats["rss"] = array ("default"=>"%rsstag%", "none"=>$notagtext );

		// Tag bar
		// Thanks http://www.cssirc.com/codes/?code=23!
		$css = '
<style type="text/css">
	.longtail, .longtail li { list-style: none; margin: 0; padding: 0; }
	.longtail li a {text-decoration:none;}
	.longtail {position: relative; height: 100px;}
	.longtail:after { display: block; visibility: hidden; content: "."; height: 0; overflow: hidden; clear: both;}
	.longtail li {float: left; position: relative; height: 100%;width: 5px;margin:0px;background-color:#fff;}
	.longtail li div {position: absolute;bottom: 0; left: 0;width: 100%;background-color:#000;}
</style>
		';
		$this->formats["weightedlongtail"] = array("pre"=>"$css<ol class=\"longtail\">", "default"=>"<li><a href=\"%tagurl%\" title=\"%tagdisplay%\"><div style=\"height:%tagrelweightint%%\">&#160;</div></a></li>", "post"=>"</ol>");;
		$this->formats["weightedlongtailvertical"] = array("pre"=>"<div class=\"longtailvert\">", "default"=>'<div style="background-color:%tagrelweightrankcolor%; width:%tagrelweightint%%; \"><a href="%tagurl%" title="%tagdisplay% (%tagcount%)" style="display:block; ">%tagdisplay%</a></div>', "post"=>"</div>");

		// Tag cloud
		$this->formats["coloredtagcloud"] = array("default"=>"<a href=\"%tagurl%\" title=\"%tagdisplay% (%tagcount%)\" style=\"color:%tagrelweightrankcolor%\">%tagdisplay%</a> ");
		$this->formats["sizedtagcloud"] = array("default"=>"<a href=\"%tagurl%\" title=\"%tagdisplay% (%tagcount%)\" style=\"font-size:%tagrelweightrankfontsize%\">%tagdisplay%</a> ");
		$this->formats["coloredsizedtagcloud"] = array("default"=>"<a href=\"%tagurl%\" title=\"%tagdisplay% (%tagcount%)\" style=\"font-size:%tagrelweightfontsize%; color:%tagrelweightrankcolor%\">%tagdisplay%</a> ");
		$this->formats["sizedcoloredtagcloud"] = $this->formats["coloredsizedtagcloud"];
		$this->formats["tagcloudlist"] = array("pre"=>"<ol>","default"=>"<li><a href=\"%tagurl%\" title=\"%tagdisplay% (%tagcount%)\" style=\"font-size:%tagrelweightfontsize%; color:%tagrelweightrankcolor%\">%tagdisplay%</a></li>", "post"=>"</ol>");
		// Thanks drac! http://lair.fierydragon.org/
		$this->formats["coloredsizedtagcloudwithcount"] = array("default"=>"<a href=\"%tagurl%\" style=\"font-size:%tagrelweightfontsize%; color:%tagrelweightrankcolor%\">%tagdisplay%<sub style=\"font-size:60%; color:#ccc;\">%tagcount%</sub></a> ");

		// Related posts
		$this->formats["postsimplelist"] = array ("default"=>"%postlink%");
		$this->formats["postcommalist"] = array ("default"=>", %postlink%", "first"=>"%postlink%", "none"=> __("No Related Posts", 'otm_domain'));
		$this->formats["posthtmllist"] = array ("default"=>"<li>%postlink%</li>", "none"=>"<li>" . __("No Related Posts", 'otm_domain') . "</li>");

	}

	function get_format($format='', $myformat=array()) {
		$this->formats = apply_filters('otm_tag_formats', $this->formats);
		if(!isset($this->formats[$format]))
			return $this->formats['default'];
		$tag_format = array_merge($this->formats[$format], (array)$myformat);
		return $tag_format;
	}

	// add custom format by hand
	// You better use add_filter('otw_tag_formats', 'your_function1'), add_filter('otw_format_tag', 'your_function2')
	// $name : format name, $format : output format
	// $replace : array, key=text, value=replacement
	// e.g. array('%customurl%'=>'http://custom.url/?tag=%tagencode%')
	function add_format($name, $format=array('default'=>'%tagdisplay%'), $replace=array()) {
		$this->formats[$name] = $format;
		if(is_array($replace) && !empty($replace))
			$this->replacer[] = $replace();
	}

	function get_tags() {
		$tags = get_tags( array('number'=>$this->number, 'orderby' => 'count', 'order' => 'DESC') ); // Always query top tags
		if ( !$tags )
			return array();
		else
			return $tags;
	}

	// borrowed from wp_generate_tag_cloud() and UTW
	function get_tag_variables($for_post=false) {
		if ( !$for_post ) {// get all tags
			$tags = $this->get_tags();
		} else {
			$tags = get_the_tags();
		}
		
		// reset previous values
		$this->counts = $this->tag_links = $this->tag_ids = $this->weights = $this->relweights = $this->weightranks = array();
		if(!$tags || empty($tags)) {
			return;
		}

		foreach ( (array) $tags as $tag ) {
			$this->counts[$tag->name] = $tag->count;
			$this->tag_links[$tag->name] = get_tag_link( $tag->term_id );
			if ( is_wp_error( $tag_links[$tag->name] ) )
				return $tag_links[$tag->name];
			$this->tag_ids[$tag->name] = $tag->term_id;
		}

		$total_counts = array_sum($this->counts);
		$max_count = max($this->counts);

		$distinctweights = array();
		foreach($this->counts as $tag => $count) {
			$this->weights[$tag] = $total_counts ? ($count/$total_counts)*100 : 0;
			$this->relweights[$tag] = $max_count ? ($count/$max_count)*100 : 0;
			$_weight = $this->relweights[$tag];
			if(!in_array($_weight, $distinctweights)) {
				$distinctweights[$_weight] = $_weight;
			}
		}
		sort($distinctweights, SORT_NUMERIC);

		foreach($this->counts as $tag => $count) {
			$this->weightranks[$tag] =  ((array_search($this->relweights[$tag], $distinctweights) + 1) / (count($distinctweights))) * 100;
		}
	}

	function get_variables($args='') {
		$args = wp_parse_args( $args, $this->op_defaults );
		extract($args);

		$this->maxsize = $largest;
		$this->minsize = $smallest;
		$this->unit = $unit;
		$this->orderby = $orderby;
		$this->order = $order;
		$this->maxcol = $maxcolor;
		$this->mincol = $mincolor;
		$this->number = $number;
		// temporary
		$this->sep = $sep;
		$this->pre = $before;
		$this->post = $after;
	}

	function generate_tag_cloud($args = '', $cloud_format = 'coloredsizedtagcloud', $myformat=array()) {
		$this->get_variables($args);
		$this->get_tag_variables();

		$cloud_formats = array('coloredtagcloud', 'sizedtagcloud', 'coloredsizedtagcloud', 'tagcloudlist', 'coloredsizedtagcloudwithcount');
		if(!in_array($cloud_format, $cloud_formats))
			$cloud_format = 'coloredsizedtagcloud';

		return $this->format_tags($cloud_format, $myformat);
	}

	function generate_tag_line($args='', $direction='vertical', $myformat=array()) {
		$this->get_variables($args);
		$this->get_tag_variables();
		$line_format = ($direction == 'vertical') ? 'weightedlongtailvertical' : 'weightedlongtail';
		return $this->format_tags($line_format, $myformat);
	}

	function format_tags($format='default', $myformat=array()) {
		$counts = $this->counts;
		$tag_format = $this->get_format($format, $myformat);

		if(empty($counts))
			return $tag_format['pre'].$tag_format['none'].$tag_format['post'];

		// SQL cannot save you; this is a second (potentially different) sort on a subset of data.
		if ( 'name' == $this->orderby )
			uksort($counts, 'strnatcasecmp');
		else
			asort($counts);

		if ( 'DESC' == $this->order )
			$counts = array_reverse( $counts, true );

		$a = array();

		$tags = array();
		// Custom format

		$output = $tag_format['pre'];
		foreach($counts as $tag=>$count) {
			$tags[] = $this->format_tag($tag_format['default'], $tag, $count);
		}
		$output .= join($this->sep, $tags);
		$output .= $tag_format['post'];

		return $output;
	}

	function format_tag($format, $tag, $count=0) {
		$tag_id = $this->tag_ids[$tag];
		$tag_display = str_replace(array('_', '-'),' ', $tag);
		$tag_name = strtolower($tag);
		$tag_name_url = urlencode($tag_name);
		$tag_link = clean_url($this->tag_links[$tag]);
		$weight = $this->weights[$tag];
		$relweight = $this->relweights[$tag];
		$weightrank = $this->weightranks[$tag];
		$rel = $this->rewrite ? ' rel="tag"' : '';


		$flickr_tag_name = urlencode(str_replace(' ', '', $tag_display));
		$wiki_tag_name = urlencode(str_replace(' ', '_', $tag_display));
		$gada_tag_name = urlencode(str_replace(' ', '.',$tag_display));
		$allblog_tag_name = str_replace('+', '%20', urlencode($tag_display));
		$tag_display = str_replace(' ', '&nbsp;', wp_specialchars( $tag_display ));
		$tag_link_rss = $this->rewrite ? $tag_link . '/feed/rss2/' : $tag_link . '&feed=rss2';

		$format = str_replace('%technoratitag%', "<a href=\"%technoratiurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%flickrtag%', "<a href=\"%flickrurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%delicioustag%', "<a href=\"%deliciousurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%wikipediatag%', "<a href=\"%wikipediaurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%gadabetag%', "<a href=\"%gadabeurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%znifftag%', "<a href=\"%zniffurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%allblogtag%', "<a href=\"%allblogurl%\" rel=\"tag\">$tag_display</a>", $format);
		$format = str_replace('%rsstag%', "<a href=\"%rssurl%\" rel=\"tag\">RSS</a>", $format);
		$format = str_replace('%localtag%', "<a href=\"%tagurl%\" rel=\"tag\">$tag_display</a>", $format);

		$format = str_replace('%technoratiurl%', "http://www.technorati.com/tag/$tag_name_url", $format);
		$format = str_replace('%flickrurl%', "http://www.flickr.com/photos/tags/$flickr_tag_name", $format);
		$format = str_replace('%deliciousurl%', "http://del.icio.us/tag/$tag_name_url", $format);
		$format = str_replace('%wikipediaurl%', "http://en.wikipedia.org/wiki/$wiki_tag_name", $format);
		$format = str_replace('%gadabeurl%', "http://$gada_tag_name.gada.be", $format);
		$format = str_replace('%zniffurl%', "http://zniff.com/?s=%22$tag_name_url%22&amp;sort=", $format);
		$format = str_replace('%allblogurl%', "http://search.allblog.net/?keyword=$allblog_tag_name", $format);
		$format = str_replace ('%rssurl%', $tag_link_rss, $format);
		$format = str_replace ('%tagurl%', $tag_link, $format);
		$format = str_replace(array('%tag%', '%tagdisplay%', '%tagencode%', '%tagid%', '%tagcount%'), array($tag_name, $tag_display, $tag_name_url, $tag_id, $count), $format);

		$format = str_replace('%tagweight%', $weight, $format);
		$format = str_replace('%tagweightint%', ceil($weight), $format);
		$format = str_replace("%tagweightcolor%", $this->GetColorForWeight($weight), $format);
		$format = str_replace("%tagweightfontsize%", $this->GetFontSizeForWeight($weight), $format);

		$format = str_replace('%tagrelweight%', $relweight, $format);
		$format = str_replace('%tagrelweightint%', ceil($relweight), $format);
		$format = str_replace("%tagrelweightcolor%", $this->GetColorForWeight($relweight), $format);
		$format = str_replace("%tagrelweightfontsize%", $this->GetFontSizeForWeight($relweight), $format);
		$format = str_replace('%tagrelweightrank%', $weightrank, $format);
		$format = str_replace('%tagrelweightrankint%', ceil($weightrank), $format);
		$format = str_replace("%tagrelweightrankcolor%", $this->GetColorForWeight($weightrank), $format);
		$format = str_replace("%tagrelweightrankfontsize%", $this->GetFontSizeForWeight($weightrank), $format);

		$format = apply_filters('otw_format_tag', $format);

		if(!empty($this->replacer)) {
			foreach($this->replacer as $text=>$rep) {
				$format = str_replace($text, $rep, $format);
			}
		}

		return $format;
	}

	// borrowed from UTW
	function GetColorForWeight($weight) {
		if ($weight) {
			$weight = $weight/100;

			$minr = hexdec(substr($this->mincol, 1, 2));
			$ming = hexdec(substr($this->mincol, 3, 2));
			$minb = hexdec(substr($this->mincol, 5, 2));

			$maxr = hexdec(substr($this->maxcol, 1, 2));
			$maxg = hexdec(substr($this->maxcol, 3, 2));
			$maxb = hexdec(substr($this->maxcol, 5, 2));

			$r = dechex(intval((($maxr - $minr) * $weight) + $minr));
			$g = dechex(intval((($maxg - $ming) * $weight) + $ming));
			$b = dechex(intval((($maxb - $minb) * $weight) + $minb));

			if (strlen($r) == 1) $r = "0" . $r;
			if (strlen($g) == 1) $g = "0" . $g;
			if (strlen($b) == 1) $b = "0" . $b;

			return "#$r$g$b";
		}
	}

	// borrowed from UTW
	function GetFontSizeForWeight($weight) {
		if ($this->unit == "") $this->unit = '%';
		if ($this->maxsize > $this->minsize) {
			$fontsize = (($weight/100) * ($this->maxsize - $this->minsize)) + $this->minsize;
		} else {
			$fontsize = (((100-$weight)/100) * ($this->maxsize - $this->minsize)) + $this->maxsize;
		}

		return intval($fontsize) . $this->unit;
	}

	function get_quried_tags($before='', $sep=array(' and ', ' or '), $after='', $echo=true) {
		$tags = get_query_var('tag');
		if ( strpos($tags, ',') !== false ) {
			$tags = preg_split('/[,\s]+/', $tags);
			$tags = join( $sep[1], (array)$tags );
		} else if ( preg_match('/[+\s]+/', $tags) ) {
			$tags = preg_split('/[+\s]+/', $tags);
			$tags = join( $sep[0], (array)$tags );
		}
		$tag_list = $before;
		$tag_list .= $tags;
		$tag_list .= $after;
		if($echo)
			echo $tag_list;
		else
			return $tag_list;
	}

	// borrowed from get_the_tag_list()
	function get_the_tag_list($format, $before, $sep, $after) {
		$this->get_variables('number=45');
		$this->get_tag_variables(true);

		$tag_format = $this->get_format($format);
		$before = ($before != '') ? $before : $tag_format['pre'];
		$after = ($after != '') ? $after : $tag_format['post'];

		if ( empty( $this->counts ) )
			return $before.$tag_format['none'].$after;

		$tag_list = $before;
		foreach ( $this->counts as $tag=>$count ) {
			$tag_links[] = $this->format_tag($tag_format['default'], $tag, $count);
		}

		$tag_links = join( $sep, $tag_links );
		$tag_list .= $tag_links;

		$tag_list .= $after;

		return $tag_list;
	}

	// borrowed from UTW
	function tag_widget() {
		$format = array(
			'pre' => '<select onchange="if (document.getElementById(\'otm-tag-menu\').value != \'\') { addTag(document.getElementById(\'otm-tag-menu\').value) }" id="otm-tag-menu"><option selected="selected" value="">'.__('Choose a tag', 'otm_domain').'</option>',
			'default' => '<option value="%tag%">%tagdisplay% (%tagcount%)</option>',
			'post' => '</select>');
		$args = 'orderby=name&order=ASC&number=0';
		$this->get_variables($args);
		$this->get_tag_variables();
		$widget = $this->format_tags('default', $format);
?>
<fieldset id="otmtagsdiv" class="dbx-box"><h3 class="dbx-handle"><?php _e('Add Existing Tag: ', 'otm_domain'); ?></h3>
<div class="dbx-content"><?php echo $widget; ?></div>
</fieldset>
<script type="text/javascript">//<![CDATA[
function addTag(tagname) {
	if (document.forms[0].tags_input.value == "") {
		document.forms[0].tags_input.value = tagname;
	} else {
		document.forms[0].tags_input.value += ", " + tagname;
	}
}
//]]></script>
<?php
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new OTM_Display();
		}
		return $instance[0];
	}

}

$otm_display =&  OTM_Display::get_instance();

function otm_quried_tags($before='', $sep=array(' and ', ' or '), $after='', $echo=true) {
	global $otm_display;
	return $otm_display->get_quried_tags($before, $sep, $after, $echo);
}

function otm_tag_cloud($args='', $cloud_format='coloredsizedtagcloud', $myformat=array()) {
	global $otm_display;
	echo $otm_display->generate_tag_cloud($args, $cloud_format, $myformat);
}

function otm_tag_line($args='orderby=count&order=DESC&number=15', $direction='vertical', $myformat=array()) {
	global $otm_display;
	echo $otm_display->generate_tag_line($args, $direction, $myformat);
}

function otm_the_tags($format='local', $before='Tags: ', $sep = ', ', $after='') {
	global $otm_display;
	echo $otm_display->get_the_tag_list($format, $before, $sep, $after);
}

add_action('dbx_post_sidebar', array(&$otm_display,'tag_widget'), 0);

?>